<script src="lib/socket.io.js"></script>
<script src="lib/PendingOperations.js"></script>
<script src="lib/Socket.js"></script>

<link rel="import" href="../polymer/polymer-element.html">
<link rel="import" href="../iron-icons/iron-icons.html">
<link rel="import" href="../paper-input/paper-input-char-counter.html">
<link rel="import" href="../paper-button/paper-button.html">
<link rel="import" href="../paper-input/paper-input.html">
<link rel="import" href="../iron-flex-layout/iron-flex-layout-classes.html">
<dom-module id="dez-collab">
	<template>
	</template>

	<script>

		class DezCollab extends Polymer.MutableData(Polymer.Element) {
			static get is() {
				return 'dez-collab';
			}
			static get properties() {
				return {
					name: String
				};
			}

 			ready() {
				super.ready();
			}

			constructor () {
				super()
				this._socket = new Socket()
			}

			async enable () {
				await this._socket.connect(() => {
					this.dispatchEvent(
						new CustomEvent('client-disconnected')
					)
				})
				this._socket.askForCurrentAnalysis()
			}

			disable () {
				this._socket.disconnect()
			}

			set analysis(analysis) {
				this._socket.analysis = analysis
				this._socket.analysis.addEventListener('label-set', event => {
					if(event.detail.doneBy == "collab") return
					if(Object.keys(event.detail.operation.changes).length == 0) return
					this._socket.emitOperation(event.detail.operation)
				});
				this._socket.analysis.addEventListener('label-created', event => {
					if (event.detail.doneBy == "init" || event.detail.doneBy == "collab") return
					this._socket.emitOperation(event.detail.operation)
				});
				this._socket.analysis.addEventListener('label-removed', event => {
					if(event.detail.doneBy == "collab") return
					this._socket.emitOperation(event.detail.operation)
				});
			}
		}
		window.customElements.define(DezCollab.is, DezCollab);
	</script>
</dom-module>
